//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Generator.Test.TestReference
{
    
    
    /// <summary>
    /// A class that exposes the ILoggingService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class LoggingServiceProvider : IFeatureProvider
    {
        
        private ILoggingService _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(LoggingServiceProvider).Assembly, "LoggingService.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public LoggingServiceProvider(ILoggingService implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterCommandWithIntermediates<ListenForLogEntriesRequestDto, LogEntry, ListenForLogEntriesIntermediateDto>("ListenForLogEntries", ListenForLogEntries, ConvertListenForLogEntriesIntermediate, null);
            registration.RegisterMetadata("LoggingActivity", _implementation.LoggingActivity);
        }
        
        private ListenForLogEntriesIntermediateDto ConvertListenForLogEntriesIntermediate(LogEntry intermediate)
        {
            return new ListenForLogEntriesIntermediateDto(intermediate, _server);
        }
        
        /// <summary>
        /// Executes the Listen for log entries command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IIntermediateObservableCommand<LogEntry> ListenForLogEntries(ListenForLogEntriesRequestDto request)
        {
            request.Validate();
            return _implementation.ListenForLogEntries();
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "tecan.sila.generator.test.logging/infrastructure/LoggingService/v4/Command/Listen" +
                "ForLogEntries"))
            {
                return typeof(ILoggingService).GetMethod("ListenForLogEntries");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
    
    /// <summary>
    /// An abstract base class to support the Logging Activity metadata
    /// </summary>
    public abstract partial class LoggingActivityInterceptorBase : Tecan.Sila2.Server.IRequestInterceptor
    {
        
        /// <summary>
        /// Gets whether the metadata applies to commands
        /// </summary>
        /// <returns>True, if the metadata is applicable to commands, otherwise false.</returns>
        public abstract bool AppliesToCommands
        {
            get;
        }
        
        /// <summary>
        /// Gets whether the metadata applies to properties
        /// </summary>
        /// <returns>True, if the metadata is applicable to properties, otherwise false.</returns>
        public abstract bool AppliesToProperties
        {
            get;
        }
        
        /// <summary>
        /// Gets the priority for the metadata
        /// </summary>
        /// <returns>A relative priority.</returns>
        public abstract int Priority
        {
            get;
        }
        
        /// <summary>
        /// Gets the metadata identifier this request interceptor is connected to or null, if not applicable
        /// </summary>
        public string MetadataIdentifier
        {
            get
            {
                return "tecan.sila.generator.test.logging/infrastructure/LoggingService/v4/Metadata/Loggi" +
                    "ngActivity";
            }
        }
        
        /// <summary>
        /// Decides whether the interceptor is required for the given command
        /// </summary>
        /// <param name="feature">The feature that contains the command or property</param>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <returns>True, if the interceptor should be applied</returns>
        public abstract bool IsInterceptRequired(Feature feature, string commandIdentifier);
        
        /// <summary>
        /// Intercepts the call to the given command
        /// </summary>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <param name="loggingActivity">The parsed metadata</param>
        /// <returns>A request interception or null, if this is not necessary</returns>
        public abstract Tecan.Sila2.Server.IRequestInterception Intercept(string commandIdentifier, string loggingActivity);
        
        /// <summary>
        /// Intercepts the call to the given command
        /// </summary>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <param name="server">The server that should execute the request</param>
        /// <param name="metadata">The metadata attached to the request</param>
        /// <returns>A request interception or null, if this is not necessary</returns>
        public Tecan.Sila2.Server.IRequestInterception Intercept(string commandIdentifier, Tecan.Sila2.Server.ISiLAServer server, Tecan.Sila2.Server.IMetadataRepository metadata)
        {
            return Intercept(commandIdentifier, Tecan.Sila2.Server.Metadata.Extract<Tecan.Sila2.StringDto>(metadata, MetadataIdentifier).Extract(server));
        }
    }
}

